<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Dashboard V2</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="./plugins/fontawesome-free/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="./dist/css/adminlte.min.css">
</head>
<body class="hold-transition sidebar-mini">
<!-- Site wrapper -->
<div class="wrapper">
  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="./index3.html" class="nav-link">Home</a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Contact</a>
      </li>
    </ul>

    <!-- Right navbar links -->
    <ul class="navbar-nav ml-auto">
      <!-- Navbar Search -->
      <li class="nav-item">
        <a class="nav-link" data-widget="navbar-search" href="#" role="button">
          <i class="fas fa-search"></i>
        </a>
        <div class="navbar-search-block">
          <form class="form-inline">
            <div class="input-group input-group-sm">
              <input class="form-control form-control-navbar" type="search" placeholder="Search" aria-label="Search">
              <div class="input-group-append">
                <button class="btn btn-navbar" type="submit">
                  <i class="fas fa-search"></i>
                </button>
                <button class="btn btn-navbar" type="button" data-widget="navbar-search">
                  <i class="fas fa-times"></i>
                </button>
              </div>
            </div>
          </form>
        </div>
      </li>

      <!-- Messages Dropdown Menu -->
      <li class="nav-item dropdown">
        <a class="nav-link" data-toggle="dropdown" href="#">
          <i class="far fa-comments"></i>
          <span class="badge badge-danger navbar-badge">3</span>
        </a>
        <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
          <a href="#" class="dropdown-item">
            <!-- Message Start -->
            <div class="media">
              <img src="./dist/img/user1-128x128.jpg" alt="User Avatar" class="img-size-50 mr-3 img-circle">
              <div class="media-body">
                <h3 class="dropdown-item-title">
                  Brad Diesel
                  <span class="float-right text-sm text-danger"><i class="fas fa-star"></i></span>
                </h3>
                <p class="text-sm">Call me whenever you can...</p>
                <p class="text-sm text-muted"><i class="far fa-clock mr-1"></i> 4 Hours Ago</p>
              </div>
            </div>
            <!-- Message End -->
          </a>
          <div class="dropdown-divider"></div>
          <a href="#" class="dropdown-item">
            <!-- Message Start -->
            <div class="media">
              <img src="./dist/img/user8-128x128.jpg" alt="User Avatar" class="img-size-50 img-circle mr-3">
              <div class="media-body">
                <h3 class="dropdown-item-title">
                  John Pierce
                  <span class="float-right text-sm text-muted"><i class="fas fa-star"></i></span>
                </h3>
                <p class="text-sm">I got your message bro</p>
                <p class="text-sm text-muted"><i class="far fa-clock mr-1"></i> 4 Hours Ago</p>
              </div>
            </div>
            <!-- Message End -->
          </a>
          <div class="dropdown-divider"></div>
          <a href="#" class="dropdown-item">
            <!-- Message Start -->
            <div class="media">
              <img src="./dist/img/user3-128x128.jpg" alt="User Avatar" class="img-size-50 img-circle mr-3">
              <div class="media-body">
                <h3 class="dropdown-item-title">
                  Nora Silvester
                  <span class="float-right text-sm text-warning"><i class="fas fa-star"></i></span>
                </h3>
                <p class="text-sm">The subject goes here</p>
                <p class="text-sm text-muted"><i class="far fa-clock mr-1"></i> 4 Hours Ago</p>
              </div>
            </div>
            <!-- Message End -->
          </a>
          <div class="dropdown-divider"></div>
          <a href="#" class="dropdown-item dropdown-footer">See All Messages</a>
        </div>
      </li>
      <!-- Notifications Dropdown Menu -->
      <li class="nav-item dropdown">
        <a class="nav-link" data-toggle="dropdown" href="#">
          <i class="far fa-bell"></i>
          <span class="badge badge-warning navbar-badge">15</span>
        </a>
        <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
          <span class="dropdown-item dropdown-header">15 Notifications</span>
          <div class="dropdown-divider"></div>
          <a href="#" class="dropdown-item">
            <i class="fas fa-envelope mr-2"></i> 4 new messages
            <span class="float-right text-muted text-sm">3 mins</span>
          </a>
          <div class="dropdown-divider"></div>
          <a href="#" class="dropdown-item">
            <i class="fas fa-users mr-2"></i> 8 friend requests
            <span class="float-right text-muted text-sm">12 hours</span>
          </a>
          <div class="dropdown-divider"></div>
          <a href="#" class="dropdown-item">
            <i class="fas fa-file mr-2"></i> 3 new reports
            <span class="float-right text-muted text-sm">2 days</span>
          </a>
          <div class="dropdown-divider"></div>
          <a href="#" class="dropdown-item dropdown-footer">See All Notifications</a>
        </div>
      </li>
      <li class="nav-item">
        <a class="nav-link" data-widget="fullscreen" href="#" role="button">
          <i class="fas fa-expand-arrows-alt"></i>
        </a>
      </li>
      <li class="nav-item">
        <a class="nav-link" data-widget="control-sidebar" data-slide="true" href="#" role="button">
          <i class="fas fa-th-large"></i>
        </a>
      </li>
    </ul>
  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="./index3.html" class="brand-link">
      <img src="./dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">AdminLTE 3</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar user (optional) -->
      <div class="user-panel mt-3 pb-3 mb-3 d-flex">
        <div class="image">
          <img src="./dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
        </div>
        <div class="info">
          <a href="#" class="d-block">Alexander Pierce</a>
        </div>
      </div>

      <!-- SidebarSearch Form -->
      <div class="form-inline">
        <div class="input-group" data-widget="sidebar-search">
          <input class="form-control form-control-sidebar" type="search" placeholder="Search" aria-label="Search">
          <div class="input-group-append">
            <button class="btn btn-sidebar">
              <i class="fas fa-search fa-fw"></i>
            </button>
          </div>
        </div>
      </div>

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item">
            <a href="#" class="nav-link">
              <i class="nav-icon fas fa-tachometer-alt"></i>
              <p>
                Dashboard
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="./Dashboard-V1.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Dashboard v1</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="./Dashboard-V2.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Dashboard v2</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="./Dashboard-V3.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Dashboard v3</p>
                </a>
              </li>
           
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Main content -->
    <section class="content">
      <!-- phần thay đổi  -->
      <h1 class="text-center">DANH SÁCH ĐƠN HÀNG </h1>
      <!-- khối lọc -->
      <div class="container jumbotron">
        <div class="row">
          <div class="col-sm-2">
            <label for="trang-thai-order">Trạng thái Order</label>
          </div>
          <div class="col-sm-3">
            <select name="" id="trang-thai-order">
              <option value="">--Chọn Trạng thái--</option>
              <option value="open">open</option>
              <option value="confirmed">confirmed</option>
              <option value="cancel">cancel</option>
            </select>
          </div>
    
          <div class="col-sm-2">
            <label for="loai-piza">Loại pizza</label>
          </div>
          <div class="col-sm-3">
            <select name="" id="loai-piza">
              <option value="">--Chọn loại pizza--</option>
              <option value="hawaii">hawaii</option>
              <option value="bacon">bacon</option>
              <option value="Seafood">seafood</option>
            </select>
          </div>
    
          <div class="col-sm-2">
            <button id="btn-loc-order-detail" class="btn btn-primary form-control">Lọc</button>
          </div>
        </div>
    
      </div>
      <!--kết thúc  khối lọc -->
      <table id="table-don-hang" class="table table-striped table-hover table-bordered">
        <thead>
          <tr>
            <th>Order code</th>
            <th>Kich co combo</th>
            <th>Loai pizza</th>
            <th>Nước uống</th>
            <th> Thành tiền</th>
            <th>Họ và tên</th>
            <th>Số điện thoại</th>
            <th>Trạng thái</th>
            <th>Chi tiết</th>
    
          </tr>
        </thead>
        <tbody>
        </tbody>
      </table>
      <!-- modal -->
      <div id="modal" class="modal fade" tabindex="-1" role="dialog">
        <div class="modal-dialog  modal-lg" role="document">
          <div class="modal-content">
            <div class="modal-header">
              <h1>Order Detail</h1>
              <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            <div class="modal-body">
              <form onsubmit="return false">
                <div class="text-center">
                  <div class="row">
                    <div class="col-sm-2">
                      <label for="inp-order-code">Order Code</label>
                    </div>
                    <div class="col-sm-10">
                      <input id="inp-order-code" class="form-control form-group " type="text" placeholder="">
                    </div>
                  </div>
    
                  <div class="row">
                    <div class="col-sm-2">
                      <label for="inp-pizza-size">Pizza Size</label>
                    </div>
                    <div class="col-sm-10">
                      <select id="select-pizza-size" class="form-control form-group" name="" id="">
                        <option value="">-- Chọn size--</option>
                      </select>
                    </div>
                  </div>
    
                  <div class="row">
                    <div class="col-sm-2">
                      <label for="ipn-duong-kinh">Đường Kính</label>
                    </div>
                    <div class="col-sm-10">
                      <input id="ipn-duong-kinh" class="form-control form-group" type="text" placeholder="">
                    </div>
                  </div>
    
                  <div class="row">
                    <div class="col-sm-2">
                      <label for="inp-suon">Sườn</label>
                    </div>
                    <div class="col-sm-10">
                      <input id="inp-suon" class="form-control form-group" type="text" placeholder="">
                    </div>
                  </div>
    
                  <div class="row">
                    <div class="col-sm-2">
                      <label for="inp-salad">Salad</label>
                    </div>
                    <div class="col-sm-10">
                      <input id="inp-salad" class="form-control form-group" type="text" placeholder="">
                    </div>
                  </div>
    
                  <div class="row">
                    <div class="col-sm-2">
                      <label for="inp-pizza-type">Pizza Type</label>
                    </div>
                    <div class="col-sm-10">
                      <input id="inp-pizza-type" class="form-control form-group" type="text" placeholder="">
                    </div>
                  </div>
    
                  <div class="row">
                    <div class="col-sm-2">
                      <label for="inp-id-voucher">ID Voucher</label>
                    </div>
                    <div class="col-sm-10">
                      <input id="inp-id-voucher" class="form-control form-group" type="text" placeholder="">
                    </div>
                  </div>
    
                  <div class="row">
                    <div class="col-sm-2">
                      <label for="inp-thanh-tien">Thành tiền</label>
                    </div>
                    <div class="col-sm-10">
                      <input id="inp-thanh-tien" class="form-control form-group" type="text" placeholder="">
                    </div>
                  </div>
    
                  <div class="row">
                    <div class="col-sm-2">
                      <label for="">Giảm Giá</label>
                    </div>
                    <div class="col-sm-10">
                      <input id="inp-giam-gia" class="form-control form-group" type="text" placeholder="">
                    </div>
                  </div>
    
                  <div class="row">
                    <div class="col-sm-2">
                      <label for="inp-loai-do-uong">Loại Đồ Uống</label>
                    </div>
                    <div class="col-sm-10">
                      <select id="inp-loai-do-uong" class="form-control form-group" name="">
                        <option value="">--chọn nước uống--</option>
                      </select>
                    </div>
                  </div>
    
                  <div class="row">
                    <div class="col-sm-2">
                      <label for="inp-so-luong-nuoc-uong">Số Lượng Nước Uống</label>
                    </div>
                    <div class="col-sm-10">
                      <input id="inp-so-luong-nuoc-uong" class="form-control form-group" type="text" placeholder="">
                    </div>
                  </div>
    
                  <div class="row">
                    <div class="col-sm-2">
                      <label for="inp-ho-va-ten">Họ Và Tên</label>
                    </div>
                    <div class="col-sm-10">
                      <input id="inp-ho-va-ten" class="form-control form-group" type="text" placeholder="">
                    </div>
                  </div>
                  <div class="row">
                    <div class="col-sm-2">
                      <label for="inp-email">Email</label>
                    </div>
                    <div class="col-sm-10">
                      <input id="inp-email" class="form-control form-group " type="text" placeholder="">
                    </div>
                  </div>
                  <div class="row">
                    <div class="col-sm-2">
                      <label for="inp-so-dien-thoai">Số Điện Thoại</label>
                    </div>
                    <div class="col-sm-10">
                      <input id="inp-so-dien-thoai" class="form-control form-group" type="text" placeholder="">
                    </div>
                  </div>
                  <div class="row">
                    <div class="col-sm-2">
                      <label for="inp-dia-chi">Địa Chỉ</label>
                    </div>
                    <div class="col-sm-10">
                      <input id="inp-dia-chi" class="form-control form-group" type="text" placeholder="">
                    </div>
                  </div>
                  <div class="row">
                    <div class="col-sm-2">
                      <label for="inp-loi-nhan">Lời Nhắn</label>
                    </div>
                    <div class="col-sm-10">
                      <input id="inp-loi-nhan" class="form-control form-group" type="text" placeholder="">
                    </div>
                  </div>
                  <div class="row">
                    <div class="col-sm-2">
                      <label for="inp-ngay-order">Ngày Order</label>
                    </div>
                    <div class="col-sm-10">
                      <input id="inp-ngay-order" class="form-control form-group" type="text" placeholder="">
                    </div>
                  </div>
                  <div class="row">
                    <div class="col-sm-2">
                      <label for="inp-ngay-chinh-sua">Ngày Chỉnh Sửa </label>
                    </div>
                    <div class="col-sm-10">
                      <input id="inp-ngay-chinh-sua" class="form-control form-group" type="text" placeholder="">
                    </div>
                  </div>
                  <div class="row">
                    <div class="col-sm-6">
                      <button id="btn-confirm" class="btn btn-warning form-control ">confirm</button>
                    </div>
                    <div class="col-sm-6">
                      <button id="btn-cancel" class="btn btn-danger form-control ">cancel</button>
                    </div>
                  </div>
              </form>
            </div>
          </div>
          <div class="modal-footer">
            <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
          </div>
        </div>
      </div>
      </div>
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->

  <footer class="main-footer">
    <div class="float-right d-none d-sm-block">
      <b>Version</b> 3.2.0
    </div>
    <strong>Copyright &copy; 2014-2023 <a href="https://adminlte.io">Devcamp.io</a>.</strong> All rights reserved.
  </footer>

  <!-- Control Sidebar -->
  <aside class="control-sidebar control-sidebar-dark">
    <!-- Control sidebar content goes here -->
  </aside>
  <!-- /.control-sidebar -->
</div>
<!-- ./wrapper -->

<!-- jQuery -->
<script src="./plugins/jquery/jquery.min.js"></script>
<!-- Bootstra/p 4 -->
<script src="./plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
<!-- AdminLTE/ App -->
<script src="./dist/js/adminlte.min.js"></script>
<!-- AdminLTE/ for demo purposes -->
<script src="./dist/js/demo.js"></script>
<!-- Data Table-->
<link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

<script>
  "use strict"

  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

  // base url API
  const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
  const gLIST_SIZE = ["S", "M", "L"];
  var gId = "";
  var gOrderCode = "";


  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  $(document).ready(function () {
    // hàm tải trang
    onPageLoading();
    // khai báo nút chi tiết 
    $(document).on("click", "#btn-loc-order-detail", onLocClick);
    // khai báo nút lọc 
    $("#table-don-hang").on("click", ".btn-chi-tiet", onChiTietClick);
    // khai báo nút confirm modal 
    $("#btn-confirm").on("click", onConfirmClick);   //nút confirm
    $("#btn-cancel").click(onCancelClick);// nút cancel


  });
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */

  function onPageLoading() {
    "use strict"
    console.log("đã load xong thẻ body ");
    loadPizzaSizeInModal(gLIST_SIZE);
    // api lấy danh sách nước uống 
    onGetDrinkListClick(function (data) {
      console.log("Nước uống: ", data);
      // load data lên modal  
      loadListDrink(data);
    });
    loadDataTable();    // khởi thạo table
    // gọi sever để lấy order deltail
    getApiListOrder(function (data) {
      console.log("list Order: ", data);
      getInsertRowTable(data);
    }
    );

  }
  // khai báo nút chi tiết 
  function onChiTietClick() {
    "use strict"

    // var vRowClick = $(this).closest("tr"); // xác định hàng của nút ấn trên table  nut ấn 
    // var vTable = $("#table-don-hang").DataTable();   // tạo biến đến dataTable 
    // var vDataRow = vTable.row(vRowClick);  // tìm hàng này trên data table trên data table 
    var gObjectRow = dataObjectRowTable(this);
    gId = gObjectRow.id;
    gOrderCode = gObjectRow.orderCode;
    console.log("id:  orderCode: ", gId, gOrderCode);
    onGetOrderByOrderCodeClick(gOrderCode, function (data) {
      console.log(" Data cho 1 order: ", data);
      // load data lên bảng modal
      loadDataInModal(data);
    });
    $("#modal").modal("show");

  }
  // khai báo nút lọc 
  function onLocClick() {
    "use strict"
    console.log("đã bấm nút Lọc ");
    // thực hiện 4 bước 
    // bước 1 .. đọc dữ liệu 
    var vObjectFilter = collectDataFilter();
    console.log(vObjectFilter);
    // bước 2 kiểm tra dữ liệu bỏ qua 
    //    bước 3 lọc
    var vObjectResult = getFilterDataTable(vObjectFilter);
    // bước 4 hiển thị
  }
  // Nút confirm modal
  function onConfirmClick() {
    "use strict"
    console.log(" đã ấn nút  confirm:");
    console.log("id Là :  ", gId);
    //04 function: đọc, validate, gọi server, xử lý data display
    // b1 đọc bỏ qua;
    // b2 validate
    if (gId != "") {
      // b3 gọi server 
      console.log("id khác khác chuỗi rỗng thì gọi server");
      // 3: trang thai open, confirmed, cancel tùy tình huống
      getApiUpdateStatus(gId, "confirmed", function (data) {
        console.log(data);
        // b4 xử lý data display
        alert("đã cập nhập trạng thái đơn hàng với id  " + gId + " là confirm.");
        $("#modal").modal("hide");
        //  load lại data table
        getApiListOrder(function (data) {
          console.log("list Order: ", data);
          getInsertRowTable(data);
        }
        );
      });
    }
  }

  // nút cancel modal 
  function onCancelClick() {
    "use strict"
    console.log(" đã ấn nút  cancel Id thu được: " , gId);
    //04 function: đọc, validate, gọi server, xử lý data display
    // b1 đọc bỏ qua;
    // b2 validate
    if (gId != "") {
      // b3 gọi server 
      console.log("id khác khác chuỗi rỗng thì gọi server");
      // 3: trang thai open, confirmed, cancel tùy tình huống
      getApiUpdateStatus(gId, "cancel", function (data) {
        console.log(data);
        // b4 xử lý data display
        alert("đã cập nhập trạng thái đơn hàng với id  " + gId + " là cancel.");
        $("#modal").modal("hide");
        //  load lại data table
        getApiListOrder(function (data) {
          console.log("list Order: ", data);
          getInsertRowTable(data);
        }
        );
      });
    }

  }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

  // load kich co lên modal 
  function loadPizzaSizeInModal(paramArr) {
    for (var i = 0; i < paramArr.length; i++) {
      var vRowOption = $("<option>").val(paramArr[i]).html(paramArr[i]);
      $("#select-pizza-size").append(vRowOption);
    }
  }

  // Mẫu gọi API để lấy danh sách đồ uống (drink list)
  function onGetDrinkListClick(paramFunction) {
    $.ajax({
      type: "GET",
      url: "http://203.171.20.210:8080/devcamp-pizza365/drinks",
      dataType: "json",
      success: paramFunction,
      error: function (error) {
        console.log(error.status);
      }
    });
  }

  // load list nước uống lên modal
  function loadListDrink(paramObject) {
    for (var i = 0; i < paramObject.length; i++) {
      var vRowDrink = paramObject[i];
      var vRowOption = $("<option>").val(vRowDrink.maNuocUong).html(vRowDrink.tenNuocUong);
      $("#inp-loai-do-uong").append(vRowOption);

    }
  }
  // api load list order 
  function getApiListOrder(paramFunction) {
    $.ajax({
      type: "GET",
      url: "http://203.171.20.210:8080/devcamp-pizza365/orders",
      dataType: "json",
      success: paramFunction,
    });
  }
  // hàm thêm từng dòng dữ liệu vào
  function loadDataTable() {
    // khai báo mảng chứa giá trị các cột 
    const ARRAY_NAME_COL = ["orderCode", "kichCo", "loaiPizza", "idLoaiNuocUong",
      "thanhTien", "hoTen", "soDienThoai", "trangThai", "chiTiet"];
    // định nghĩa số thứ tự cho các cột 
    const COL_ORDER_CODE = 0;
    const COL_KICH_CO = 1;
    const COL_LOAI_PIZZA = 2;
    const COL_LOAI_NUOC_UONG = 3;
    const COL_THANH_TIEN = 4;
    const COL_HO_TEN = 5;
    const COL_SO_DIEN_THOAI = 6;
    const COL_TRANG_THAI = 7;
    const COL_CHI_TIET = 8;
    // cấu hình lại table
    // Khi load (tải) trang thì hiển thị toàn bộ dữ liệu user (Tách thành 04 bước) => 1 bước 
    $("#table-don-hang").DataTable({
      paging: true,   // phân trang
      lengthChange: true,  // ố bản ghi / mỗi trang
      searching: true,  // tìm kiếm 
      ordering: false,    //sắp xếp
      columns: [
        { data: ARRAY_NAME_COL[COL_ORDER_CODE] },
        { data: ARRAY_NAME_COL[COL_KICH_CO] },
        { data: ARRAY_NAME_COL[COL_LOAI_PIZZA] },
        { data: ARRAY_NAME_COL[COL_LOAI_NUOC_UONG] },
        { data: ARRAY_NAME_COL[COL_THANH_TIEN] },
        { data: ARRAY_NAME_COL[COL_HO_TEN] },
        { data: ARRAY_NAME_COL[COL_SO_DIEN_THOAI] },
        { data: ARRAY_NAME_COL[COL_TRANG_THAI] },
        { data: ARRAY_NAME_COL[COL_CHI_TIET] },
      ],
      columnDefs: [

        {
          targets: COL_CHI_TIET,
          className: "text-center",
          defaultContent: `
                          <i style="cursor: -webkit-grab; cursor: grab;" class="fa-solid fa-circle-info btn-chi-tiet" aria-hidden="true" data-toggle="tooltip" data-placement="top" title="chi tiết"></i>
          `,
        },
      ],
    });

  }
  // hàm thêm từng dòng dữ liệu vào
  function getInsertRowTable(paramRes) {
    var vTable = $("#table-don-hang").DataTable();
    vTable.clear();// xóa trắng tbody trước khi load dữ liệu  
    vTable.rows.add(paramRes);
    vTable.draw();
  }


  // ...................................[nút LỌC]............................
  // b1 thu thập dữ liệu 
  function collectDataFilter() {
    //khai báo đối tượng để lưu trữ 
    var vObjectFilter = {
      status: "",
      type: "",
    }
    vObjectFilter.status = $("#trang-thai-order").val().trim();
    vObjectFilter.type = $("#loai-piza").val().trim();
    // trả về giá trị và kết thúc hàm 
    return vObjectFilter;
  }
  // bước  2 . kiểm tra dữ liệu bỏ qua

  // bước 3 . lọc 
  function getFilterDataTable(paramObject) {
    // gọi sever để lấy order deltail
    getApiListOrder(function (data) {
      console.log(data);
      var filtered = data.filter(function (str) {

        var vLoaiPizza = "";
        var vTrangThai = "";
        vLoaiPizza = str.loaiPizza;
        vTrangThai = str.trangThai;
        if (vLoaiPizza != null) {
          return (vLoaiPizza.toLowerCase().includes(paramObject.type.toLowerCase()))
            && (vTrangThai.toLowerCase().includes(paramObject.status.toLowerCase()));
        }
      });
      getInsertRowTable(filtered);

    }
    );
    // bước 4 hiển thị lên font end 
  }
  // ...................chi tiết .................

  // Mẫu gọi API lấy 1 order dựa vào orderCode
  function onGetOrderByOrderCodeClick(paramOrderCode, paramFunction) {
    $.ajax({
      type: "GET",
      url: gBASE_URL + "/" + paramOrderCode,
      dataType: "json",
      success: paramFunction,
      error: function (erro) {
        console.log(error.status)
      }
    });
  }

  // lấy object của 1 hàng trên table 
  function dataObjectRowTable(paramThis) {
    var vRowClick = $(paramThis).closest("tr"); // xác định hàng của nút ấn trên table  nut ấn 
    var vTable = $("#table-don-hang").DataTable();   // tạo biến đến dataTable 
    var vDataRow = vTable.row(vRowClick);  // tìm hàng này trên data table trên data table 
    return vDataRow.data();
  }
  // load data in modal
  function loadDataInModal(paramObject) {
    $("#inp-order-code").val(paramObject.orderCode);
    $("#select-pizza-size").val(paramObject.kichCo);
    $("#ipn-duong-kinh").val(paramObject.duongKinh);
    $("#inp-suon").val(paramObject.suon);
    $("#inp-salad").val(paramObject.salad);
    $("#inp-pizza-type").val(paramObject.loaiPizza);
    $("#inp-id-voucher").val(paramObject.idVourcher);
    $("#inp-thanh-tien").val(paramObject.thanhTien);
    $("#inp-giam-gia").val(paramObject.giamGia);
    $("#inp-loai-do-uong").val(paramObject.idLoaiNuocUong);
    $("#inp-so-luong-nuoc-uong").val(paramObject.soLuongNuoc);
    $("#inp-ho-va-ten").val(paramObject.hoTen);
    $("#inp-email").val(paramObject.email);
    $("#inp-so-dien-thoai").val(paramObject.soDienThoai);
    $("#inp-dia-chi").val(paramObject.diaChi);
    $("#inp-loi-nhan").val(paramObject.loiNhan);
    $("#inp-ngay-order").val(paramObject.ngayTao);
    $("#inp-ngay-chinh-sua").val(paramObject.ngayCapNhat);

  }

  // .............................[nút confirm ]..................
  // update trang thái confirm bằng id 
  function getApiUpdateStatus(paramId, paramTrangThai, paramFunction) {
    var vObjectRequest = {
      trangThai: paramTrangThai, // 3: trang thai open, confirmed, cancel tùy tình huống
    }
    $.ajax({
      type: "PUT",
      url: gBASE_URL + "/" + paramId,
      data: JSON.stringify(vObjectRequest),
      dataType: "json",
      contentType: "application/json;charset=UTF-8",
      success: paramFunction,
    });
  }

</script>
</body>
</html>
